<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>

        </v-breadcrumbs>
      </div>
      <strong>Historial de Hallazgos</strong>
    </div>
    <div class="contSecc">
      <busqueda-resumen 
        :idCeco = idCeco
        :idFase = idFase
        :idProyecto = idProyecto />

      <div class="titSec ">Historial de hallazgos</div>

      <div class="gris">
      
         <div class="txtInfo">
           {{dataJson[0].preg}}
        </div>
        <hr class="hrSeccion" />
        <!--
        <div
          class="historia-hallazgos"
          v-for="historia in bdHistorial"
          :key="historia.estatus"
        >
          <div class="historia-txt">
            {{ historia.fecha }}<br />{{ historia.hora }}
          </div>
          <div>
            <div
              class="paso"
              v-bind:class="{
                bgV: historia.respuesta == 'Sí',
                bgR: historia.respuesta == 'No',
              }"
            >
              {{ historia.respuesta }}
            </div>
          </div>
          <div><img :src="historia.img" class="historia-img" /></div>

          <div>
            <div class="historia-txt demi">{{ historia.estatus }}</div>

            Persona que levantó el hallazgos
            <div class="historia-txt">{{ historia.responsable }}</div>

            Comentario
            <div class="historia-txt">{{ historia.comentario }}</div>
          </div>
        </div>
        -->
        <div class="btnCenter">
          <v-timeline  dense align-top  > 
            <v-timeline-item
              v-for="(item, i) in this.bdHistorial"
              :key="i"
              fill-dot
              
            >
              <!-- Rojo ::: #fd5151 ___ Verde ::: #4CAF54 "{{item.color}}" -->
              <template v-slot:icon>
                <div
                  class="respuesta-style"
                  :style="{ 'background-color': item.color }">
                  <p class="txtRespuesta">
                    {{ item.respuesta }}
                  </p>
                </div>
              </template>

              <v-card class="elevation-2" > 
                <v-card-title class="title">{{ item.estatus }}</v-card-title>
                <v-card-text class="white text--primary">
                  <div><img :src="item.img" class="historia-img" /></div>

                  Comentario:
                  <div class="historia-txt">{{ item.comentario }}</div>

                  Fecha:
                  <div class="historia-txt">
                    {{ item.fecha }} {{ item.hora }}
                  </div>
                  <div>
                    Persona que levantó el hallazgo:
                    <div class="historia-txt">{{ item.responsable }}</div>
                  </div>
                </v-card-text>
              </v-card>
            </v-timeline-item>
          </v-timeline>
        </div>
        <div class="btnCenter">
          <button class="btn btnG" @click="$router.go(-1)">Regresar</button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import BusquedaResumen from "@/views/secure/infraestructura/components/busqueda-resumen";
import store from "@/store";
const serviceCommons = store.state.serviceCommons;

export default {
  name: "Component-busquedaDetalle",
  components: {
    BusquedaResumen,
  },
  data () {
    return({
     
    cecoFaseProyecto: "", 
    idCeco : "",
    idFase : "",
    idProyecto : "",
    densed : true,
    detalleHallazgo: "",
    hallazgos: [],
    idHallazgo: 0,
    dataJson: "",

    //INICIO
    items: [
      {
        color: "red lighten-2",
        icon: "mdi-star",
      },
      {
        color: "purple darken-1",
        icon: "mdi-book-variant",
      },
      {
        color: "green lighten-1",
        icon: "mdi-airballoon",
      },
      {
        color: "indigo",
        icon: "mdi-buffer",
      },
    ],
    //FIN

    breadcrumbs: [],

    bdHistorial: [
      {
        idHallazgo: "1",
        estatus: "Autorizado",
        respuesta: "Sí",
        responsable: "189871 - DESDEWEB",
        fecha: "30/03/2020",
        hora: "17:26",
        comentario: "Se atendió",
        img: require("@/assets/img/hallazgos/tiendas/elektra1.jpg"),
      },
      {
        idHallazgo: "2",
        estatus: "Rechazado/Pendiente por atender",
        respuesta: "No",
        responsable: "189871 - DESDEWEB",
        fecha: "30/03/2020",
        hora: "17:26",
        comentario: "No se muestra correctamente en la fachada",
        img: require("@/assets/img/hallazgos/tiendas/elektra2.jpg"),
      },
      {
        idHallazgo: "3",
        estatus: "Por autorizar",
        respuesta: "No",
        responsable: "189871 - DESDEWEB",
        fecha: "06/02/2020",
        hora: "17:26",
        comentario: "No se realizó bien la modificación",
        img: require("@/assets/img/hallazgos/tiendas/elektra3.jpg"),
      },
      {
        idHallazgo: "4",
        estatus: "Por atender",
        respuesta: "No",
        responsable: "Carga Manual",
        fecha: "15/03/2020",
        hora: "17:26",
        comentario: "La colaboración del material es incorrecta",
        img: require("@/assets/img/hallazgos/tiendas/elektra4.jpg"),
      },
    ],
  })
  },
  created() {

    
    this.dataJson = this.$route.params.dataJson;
    
    this.idCeco = this.$route.params.idCeco;
    this.idFase = this.$route.params.idFase;
    this.idProyecto = this.$route.params.idProyecto;

    //Se agrega el nombre de ceco y numero de ceco 
    this.nombreCeco =  this.$route.params.nombreCecoParam,
    this.numCeco = this.$route.params.numCecoParam

    const dataTransfer = {
        idProyecto: this.idProyecto,
        idFase: this.idFase,
        idCeco: this.idCeco,
        nombreCecoParam :  this.nombreCeco,
        numCeco : this.numCecoParam

    };

    this.cecoFaseProyecto = serviceCommons.objectToBase64(dataTransfer);

    this.initBreadcrumbs();
    this.initData(this.dataJson);

    console.log(JSON.stringify(this.dataJson));
  },
  methods: {
    initBreadcrumbs(){
      this.breadcrumbs = [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Entrega",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_entrega"
          }
        },
        {
          text: "Busqueda Hallazgos",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_atencion_hallazgos"
            },
        },
        {
          text: "Listado hallazgos",
          disabled: false,
          exact: true,
          to: {
          name :"modelo_franquicia_lista_hallazgos",
          params: {
            cecoFaseProyecto: this.cecoFaseProyecto
            }
          }
        },
      {
        text: "Hitorial del Hallazgo",
        disabled: true,
      }
      ]
    },
    initData(data) {
      this.bdHistorial = [];

      if (data != null && data.length > 0) {
        Object.keys(data).forEach((key) => {
          var obj = data[key];

          //La fecha del primer item es fechaIni
          var fechaComParam = obj.periodo;
          var horaParam = "";
          var fechaParam = "";
          //Cuando el key 0
          var comentarioParam = obj.disposi;
          var colorParam = "#fd5151";
          //#4CAF54

          if (obj.status == 3) {
            colorParam = "#4CAF54";
          }

          if (key == data.length - 1) {
            fechaComParam = obj.fechaIni;
            comentarioParam = obj.obs;
          }

          fechaParam = fechaComParam.split(" ")[0];
          horaParam = fechaComParam.split(" ")[1];

          var jsonItem = {
            color: colorParam,
            idHallazgo: obj.idHallazgo,
            estatus: this.getStatus(obj.status),
            respuesta: obj.respuesta,
            responsable: obj.usuModif,
            fecha: this.formatDate(fechaParam),
            hora: horaParam,
            comentario: comentarioParam,
            img: "http://10.53.33.82" + obj.ruta,
            //img: "http://10.51.218.104:80" + obj.ruta,
          };

          this.bdHistorial.push(jsonItem);
        });
      }
    },
    getStatus(status) {
      var estado = "";

      switch (status) {
        case 0:
          estado = "Rechazado por Atender";
          break;
        case 1:
          estado = "Por Atender";
          break;
        case 2:
          estado = "Por Autorizar";
          break;
        case 3:
          estado = "Atendido";
          break;
      }

      return estado;
    },
    formatDate(input) {
      var datePart = input.match(/\d+/g),
        year = datePart[0].substring(2), // get only two digits
        month = datePart[1],
        day = datePart[2];

      return day + "/" + month + "/" + year;
    },
  },
};
</script>

<style scoped>
div.v-timeline-item.v-timeline-item--fill-dot.theme--light {
  width: 400px;
}
.respuesta-style {
  color: white;
  width: 100%;
  background-color: #fd5151;
  height: 100%;
  border-bottom-right-radius: 30px;
  border-top-right-radius: 30px;
  border-bottom-left-radius: 30px;
  border-top-left-radius: 30px;
  text-align: center;
}

.txtRespuesta {
  margin-top: 25%;
}

.historia-img {
  width: 275px;
  height: 250px;
}
.historia-hallazgos {
  display: flex;
  margin-bottom: 20px;
  max-width: 860px;
  margin: 0px auto 20px auto;
}
.historia-hallazgos > div {
  margin: 0px 2%;
  position: relative;
}
.historia-txt {
  font-size: 15px;
  font-family: "AvenirNextLTPro-Medium";
  margin-bottom: 20px;
}

.paso {
  width: 40px;
  height: 40px;
  border-radius: 50%;
  display: flex;
  justify-content: center;
  align-items: center;
  color: #ffffff;
}
.paso:after {
  content: "";
  background-color: #ccc;
  position: absolute;
  top: 40px;
  /* right: 16%; */
  width: 2px;
  height: 194px;
  z-index: 0;
}
.historia-hallazgos:nth-last-child(n) > div:nth-last-child(2)::before {
  background-color: red;
}
.historia-hallazgos:nth-last-child(n) > div div.paso::before {
  content: "";
  background-color: #ccc;
  width: 16px;
  height: 16px;
  border-radius: 50%;
  position: absolute;
  top: 235px;
}
</style>
